subroutine aprep(fc,fg,fcs,fgs,paican,paicns,fsvf,fsvfs, &
                       frainc,fsnowc,fraics,fsnocs,raican,raicns,snocan, &
                       snocns,disp,disps,zomlnc,zomlcs,zoelnc,zoelcs, &
                       zomlng,zomlns,zoelng,zoelns,chcap,chcaps,cmassc, &
                       cmascs,cwlcap,cwfcap,cwlcps,cwfcps,rbcoef, &
                       zplimc,zplimg,zplmcs,zplmgs,htcc,htcs,htc, &
                       froot,froots, &
                       wtrc,wtrs,wtrg,cmai,pai,pais,ail,fcan,fcans,psignd, &
                       fcanmx,zoln,paimax,paimin,cwgtmx,zrtmax, &
                       paidat,hgtdat,thliq,thice,tbar,rcan,sncan, &
                       tcan,growth,zsnow,tsnow,fsnow,rhosno,sno,z0oro, &
                       zblend,zplmg0,zplms0, &
                       ta,rhoair,radj,dlon,rhosni,delz,delzw,zbotw, &
                       thpor,thlmin,psisat,bi,psiwlt,hcps,isand, &
                       ilg,il1,il2,jl,ic,icp1,ig,iday,idisp,izref,iwf, &
                       ipai,ihgt,rmat,h,hs,cwcpav,growa,grown,growb, &
                       rresid,sresid,frtot,frtots, &
                       fcancmx,ictem,ictemmod,rmatc, &
                       ailc,paic,ailcg,l2max,nol2pfts, &
                       ailcgs,fcancs,fcanc,slaic)

  !     * aug 04/15 - d.verseghy. split froot into two arrays, for canopy
  !     *                         areas with and without snow.
  !     * sep 05/12 - j.melton.   changed iday
  !                               conversion from float to real, reintegrated
  !                               ctem
  !     * nov 15/11 - m.lazare.   ctem added. calculations are different
  !     *                         in several areas, under control of
  !     *                         "ICTEMMOD" switch (ictemmod=0 reverts
  !     *                         back to aprep4 formulation). this
  !     *                         includes new input "PAIC".
  !     * oct 07/11 - v.fortin/d.verseghy. make the limiting ponding depth
  !     *                         calculation over organic soils the same
  !     *                         as over mineral soils (loop 175).
  !     * dec 23/09 - d.verseghy. in limiting ponding depth calculations,
  !     *                         identify peatlands where isand(i,2)=-2
  !     * jan 06/09 - d.verseghy. reintroduce checks on fractional areas.
  !     * mar 25/08 - d.verseghy. distinguish between leaf area index
  !     *                         and plant area index.
  !     * jan 17/08 - d.verseghy. streamline some calculations; remove
  !     *                         superfluous checks on fractional areas.
  !     * nov 30/06 - e.chan/m.lazare/d.verseghy. change radj to real
  !     *                         ensure consistency in calculation
  !     *                         of fractional canopy areas.
  !     * sep 13/05 - d.verseghy. remove hard coding of ig=3 in 100,
  !     *                         450 loops.
  !     * mar 14/05 - d.verseghy. rename scan to sncan (reserved name
  !     *                         in f90); treat soil frozen water as ice
  !     *                         volume rather than as equivalent water.
  !     * mar 03/05 - y.delage.   add contribution of subgrid-scale
  !     *                         orography to roughness length.
  !     * jan 12/05 - p.bartlett/d.verseghy. determine separate canopy
  !     *                         water interception capacities for
  !     *                         rain and snow, and new fractional
  !     *                         canopy coverage of intercepted rain
  !     *                         and snow; define new parameter rbcoef
  !     *                         for rbinv calculation in tsolvc.
  !     * nov 03/04 - d.verseghy. change radj and dlon to gathered
  !     *                         variables and remove iland array
  !     *                         add "IMPLICIT NONE" command.
  !     * jul 05/04 - y.delage/d.verseghy. protect sensitive calculations
  !     *                         against roundoff errors.
  !     * jul 02/03 - d.verseghy. rationalize assignment of residual
  !     *                         canopy moisture to soil layers.
  !     * dec 05/02 - y.delage/d.verseghy. add parts of canopy air mass to
  !     *                         canopy mass only if idisp=0 or izref=2.
  !     *                         also, replace logarithmic averaging of
  !     *                         roughness heights with blending height
  !     *                         averaging.
  !     * jul 31/02 - d.verseghy. move calculation of psignd and full
  !     *                         calculation of froot into this routine
  !     *                         from tprep; remove calculation of rcmin.
  !     *                         shortened class3 common block.
  !     * jul 23/02 - d.verseghy. move addition of air to canopy mass
  !     *                         into this routine; shortened class4
  !     *                         common block.
  !     * mar 18/02 - d.verseghy. move calculation of soil properties into
  !     *                         routine "CLASSB"; allow for assignment
  !     *                         of specified time-varying vegetation
  !     *                         height and leaf area index.
  !     * sep 19/00 - d.verseghy. add calculation of vegetation-dependent
  !     *                         coefficients for determination of stomatal
  !     *                         resistance.
  !     * apr 12/00 - d.verseghy. rcmin now varies with vegetation type:
  !     *                         pass in background array "RCMINX".
  !     * dec 16/99 - a.wu/d.verseghy. add calculation of new leaf dimension
  !     *                              parameter for revised canopy turbulent
  !     *                              transfer formulation.
  !     * nov 16/98 - m.lazare.   "DLON" now passed in and used directly
  !     *                         (instead of inferring from "LONSL" and
  !     *                         "ILSL" which used to be passed) to calculate
  !     *                         growth index. this is done to make the physics
  !     *                         plug compatible for use with the rcm which
  !     *                         does not have equally-spaced longitudes.
  !     * jun 20/97 - d.verseghy. class - version 2.7.
  !     *                         modifications to allow for variable
  !     *                         soil permeable depth.
  !     * oct 11/96 - d.verseghy. class - version 2.6.
  !     *                         bug fix: to avoid round-off errors,
  !     *                         set canopy cover equal to 1 if the
  !     *                         calculated sum of fc and fcs is
  !     *                         very close to 1.
  !     * jan 02/96 - d.verseghy. class - version 2.5.
  !     *                         completion of energy balance
  !     *                         diagnostics.
  !     *                         also correct bug in calculation of
  !     *                         deglon, and use idisp to determine
  !     *                         method of calculating disp and disps.
  !     * aug 30/95 - d.verseghy. class - version 2.4.
  !     *                         variable surface detention capacity
  !     *                         implemented.
  !     * aug 16/95 - d.verseghy. three new arrays to complete water
  !     *                         balance diagnostics.
  !     * nov 22/94 - d.verseghy. class - version 2.3.
  !     *                         rationalize calculation of rcmin.
  !     * nov 12/94 - d.verseghy. fix bugs in senescing limb of crop
  !     *                         growth index and in canopy mass
  !     *                         calculation.
  !     * may 06/93 - m.lazare/d.verseghy. class - version 2.1.
  !     *                                  use new "CANEXT" canopy
  !     *                                  extinction array to define
  !     *                                  sky-view factors. also, correct
  !     *                                  minor bug where had "IF (IN<=9)..."
  !     *                                  instead of "IF (IN>9)...".
  !     * dec 12/92 - m.lazare.   modified for multiple latitudes.
  !     * oct 24/92 - d.verseghy/m.lazare. revised and vectorized code
  !     *                                  for model version gcm7.
  !     * aug 12/91 - d.verseghy. calculation of land surface canopy
  !     *                         parameters.
  !
  use times_mod, only : delt
  use hydcon, only : tfrez, hcpw, hcpice, hcpsnd, rhow, rhoice, &
                     sphair, sphice, sphveg, sphw, &
                     pi, growyr, zolng, zolns, zolni, zorat, zoratg, canext, xleaf
  !
  implicit none
  !
  !     * integer :: constants.
  !
  integer, intent(in) :: ilg   !< Total number of atmospheric columns \f$[unitless]\f$
  integer, intent(in) :: il1   !< Index of first atmospheric column for calculations \f$[unitless]\f$
  integer, intent(in) :: il2   !< Index of last atmospheric column for calculations \f$[unitless]\f$
  integer, intent(in) :: jl !<
  integer, intent(in) :: ic !<
  integer, intent(in) :: icp1 !<
  integer, intent(in) :: ig !<
  integer, intent(in) :: iday   !< Julian calendar day of year \f$[day]\f$
  integer, intent(in) :: idisp !<
  integer, intent(in) :: izref !<
  integer, intent(in) :: iwf !<
  integer, intent(in) :: ipai !<
  integer, intent(in) :: ihgt !<
  !
  !     * output arrays used else where in class.
  !
  real, intent(inout) :: fc    (ilg) !<
  real, intent(inout) :: fg    (ilg) !<
  real, intent(inout) :: fcs   (ilg) !<
  real, intent(inout) :: fgs   (ilg) !<
  real, intent(inout) :: paican(ilg) !<
  real, intent(inout) :: paicns(ilg) !<
  real, intent(inout) :: fsvf  (ilg) !<
  real, intent(inout) :: fsvfs (ilg) !<
  real, intent(inout) :: frainc(ilg) !<
  real, intent(inout) :: fsnowc(ilg) !<
  real, intent(inout) :: fraics(ilg) !<
  real, intent(inout) :: fsnocs(ilg) !<
  real, intent(inout) :: raican(ilg) !<
  real, intent(inout) :: raicns(ilg) !<
  real, intent(inout) :: snocan(ilg) !<
  real, intent(inout) :: snocns(ilg) !<
  real, intent(inout) :: disp  (ilg) !<
  real, intent(inout) :: disps (ilg) !<
  real, intent(inout) :: zomlnc(ilg) !<
  real, intent(inout) :: zomlcs(ilg) !<
  real, intent(inout) :: zoelnc(ilg) !<
  real, intent(inout) :: zoelcs(ilg) !<
  real, intent(inout) :: zomlng(ilg) !<
  real, intent(inout) :: zomlns(ilg) !<
  real, intent(inout) :: zoelng(ilg) !<
  real, intent(inout) :: zoelns(ilg) !<
  real, intent(inout) :: rbcoef(ilg) !<
  real, intent(inout) :: chcap (ilg) !<
  real, intent(inout) :: chcaps(ilg) !<
  real, intent(inout) :: cmassc(ilg) !<
  real, intent(inout) :: cmascs(ilg) !<
  real, intent(inout) :: cwlcap(ilg) !<
  real, intent(inout) :: cwfcap(ilg) !<
  real, intent(inout) :: cwlcps(ilg) !<
  real, intent(inout) :: cwfcps(ilg) !<
  real, intent(inout) :: zplimc(ilg) !<
  real, intent(inout) :: zplimg(ilg) !<
  real, intent(inout) :: zplmcs(ilg) !<
  real, intent(inout) :: zplmgs(ilg) !<
  real, intent(inout) :: htcc  (ilg) !<
  real, intent(inout) :: htcs  (ilg) !<
  real, intent(inout) :: wtrc  (ilg) !<
  real, intent(inout) :: wtrs  (ilg) !<
  real, intent(inout) :: wtrg  (ilg) !<
  real, intent(inout) :: cmai  (ilg) !<
  !
  real, intent(inout) :: froot (ilg,ig) !<
  real, intent(inout) :: froots(ilg,ig) !<
  real, intent(inout) :: htc   (ilg,ig) !<
  !
  !     * output arrays only used else where in classa.
  !
  real, intent(inout) :: pai   (ilg,ic) !<
  real, intent(inout) :: pais  (ilg,ic) !<
  real, intent(inout) :: ail   (ilg,ic) !<
  real, intent(inout) :: fcan  (ilg,ic) !<
  real, intent(inout) :: fcans (ilg,ic) !<
  real, intent(inout) :: psignd(ilg) !<
  !
  !     * input arrays.
  !
  real, intent(inout) :: fcanmx(ilg,icp1) !<
  real, intent(in) :: zoln  (ilg,icp1) !<
  real, intent(inout) :: paimax(ilg,ic) !<
  real, intent(inout) :: paimin(ilg,ic) !<
  real, intent(in) :: cwgtmx(ilg,ic) !<
  real, intent(in) :: zrtmax(ilg,ic) !<
  real, intent(inout) :: paidat(ilg,ic) !<
  real, intent(inout) :: hgtdat(ilg,ic) !<
  real, intent(inout) :: thliq (ilg,ig) !<
  real, intent(inout) :: thice (ilg,ig) !<
  real, intent(inout) :: tbar  (ilg,ig) !<
  !
  real, intent(inout) :: rcan  (ilg) !<
  real, intent(inout) :: sncan (ilg) !<
  real, intent(inout) :: tcan  (ilg) !<
  real, intent(in) :: growth(ilg) !<
  real, intent(inout) :: zsnow (ilg) !<
  real, intent(inout) :: tsnow (ilg) !<
  real, intent(inout) :: fsnow (ilg) !<
  real, intent(in) :: rhosno(ilg) !<
  real, intent(inout) :: sno   (ilg) !<
  real, intent(in) :: ta    (ilg) !<
  real, intent(in) :: rhoair(ilg) !<
  real, intent(in) :: dlon  (ilg) !<
  real, intent(in) :: z0oro (ilg) !<
  real, intent(in) :: zblend(ilg) !<
  real, intent(in) :: rhosni(ilg) !<
  real, intent(in) :: zplmg0(ilg) !<
  real, intent(in) :: zplms0(ilg) !<
  real, intent(in) :: radj  (ilg)   !< Latitude \f$[radians]\f$
  !
  !     * soil property arrays.
  !
  real, intent(in) :: delzw(ilg,ig) !<
  real, intent(in) :: zbotw(ilg,ig) !<
  real, intent(in) :: thpor(ilg,ig) !<
  real, intent(in) :: thlmin(ilg,ig) !<
  real, intent(in) :: psisat(ilg,ig) !<
  real, intent(in) :: bi   (ilg,ig) !<
  real, intent(in) :: psiwlt(ilg,ig) !<
  real, intent(inout) :: hcps (ilg,ig) !<
  !
  integer, intent(in), dimension(ilg,ig) :: isand !<
  !
  real, intent(in) :: delz  (ig) !<
  !
  !     * ctem-related fields.
  !
  real, intent(inout)  :: ailc (ilg,ic) !<
  real, intent(inout)  :: paic   (ilg,ic) !<
  real, intent(inout)  :: ailcg(ilg,ictem) !<
  real, intent(inout)  :: ailcgs (ilg,ictem) !<
  real, intent(inout)  :: rmatc(ilg,ic,ig) !<
  real, intent(inout)  :: fcancmx(ilg,ictem) !<
  real, intent(inout)  :: fcanc(ilg,ictem) !<
  real, intent(inout)  :: fcancs (ilg,ictem) !<
  real, intent(in)  :: slaic(ilg,ic) !<
  !
  !     * work arrays not used else where in classa.
  !
  real, intent(inout) :: rmat (ilg,ic,ig) !<
  real, intent(inout) :: h     (ilg,ic) !<
  real, intent(inout) :: hs    (ilg,ic) !<
  real, intent(in) :: cwcpav(ilg) !<
  real, intent(inout) :: growa (ilg) !<
  real, intent(inout) :: grown (ilg) !<
  real, intent(inout) :: growb (ilg) !<
  real, intent(inout) :: rresid(ilg) !<
  real, intent(inout) :: sresid(ilg) !<
  real, intent(inout) :: frtot (ilg) !<
  real, intent(inout) :: frtots(ilg) !<
  !
  integer, intent(in) :: ictem !<
  integer, intent(in) :: l2max !<
  integer, intent(in) :: nol2pfts(ic) !<
  integer, intent(in) :: ictemmod !<
  !
  !     * temporary variables.
  !
  integer :: i !<
  integer :: j !<
  integer :: k !<
  integer :: in !<
  integer :: nl !<
  real :: day !<
  real :: growg !<
  real :: fsum !<
  real :: snoi !<
  real :: zsnadd !<
  real :: thsum !<
  real :: thicei !<
  real :: thliqi !<
  real :: zroot !<
  real :: zrootg !<
  real :: fcoeff !<
  real :: psii !<
  real :: lz0oro !<
  real :: thr_lai !<
  real :: psirat !<
  !
  !     * ailcg  - green lai for use with phtsyn subroutine
  !     * ailcgs - green lai for canopy over snow sub-area
  !     * nol2pfts - number of level 2 ctem pfts
  !     * FCANC  - FRACTION OF CANOPY OVER GROUND FOR CTEM's 9 PFTs
  !     * FCANCS - FRACTION OF CANOPY OVER SNOW FOR CTEM's 9 PFTs
  !     * see bio2str subroutine for explanation of other ctem variables

  !     * internal work field.
  !
  real, dimension(ilg,ic) :: sfcancmx !<
  !
  integer :: m !<
  integer :: n !<
  integer :: k1 !<
  integer :: k2 !<
  !
  !-----------------------------------------------------------------------
  if (ic/=4)                               call xit('APREP',-2)
  !
  !     * initialize diagnostic and other arrays.
  !
  do i=il1,il2
    htcc(i) =0.0
    htcs(i) =0.0
    do j=1,ig
      htc(i,j)=0.0
    end do ! loop 50
    wtrc(i) =0.0
    wtrs(i) =0.0
    wtrg(i) =0.0
    frtot(i)=0.0
    frtots(i)=0.0
    disp  (i)=0.
    zomlnc(i)=0.
    zoelnc(i)=1.
    disps (i)=0.
    zomlcs(i)=0.
    zoelcs(i)=1.
    zomlng(i)=0.
    zoelng(i)=0.
    zomlns(i)=0.
    zoelns(i)=0.
    cmassc(i)=0.
    cmascs(i)=0.
    psignd(i)=1.0e+5
  end do ! loop 100
  !
  !     * determine growth index for crops (vegetation type 3).
  !     * must use un-gathered longitudes to compute actual longitude/
  !     * latitude values.
  !
  day=real(iday)
  !
  !     * for ctem, crop growth is built in, so growa=1.
  !
  if (ictemmod==0) then
    do i=il1,il2
      in = int( (radj(i)+pi/2.0)*18.0/pi) + 1
      if (dlon(i)>190. .and. dlon(i)<330.) then
        nl=2
      else
        nl=1
      end if
      if (growyr(in,1,nl)<0.1) then
        growa(i)=1.0
      else
        if (in>9) then
          if (day>=growyr(in,2,nl).and.day<growyr(in,3,nl)) &
              growa(i)=1.0
          if (day>=growyr(in,4,nl).or.day<growyr(in,1,nl)) &
              growa(i)=0.0
        else
          if (day>=growyr(in,2,nl).or.day<growyr(in,3,nl)) &
              growa(i)=1.0
          if (day>=growyr(in,4,nl).and.day<growyr(in,1,nl)) &
              growa(i)=0.0
        end if
        if (day>=growyr(in,1,nl).and.day<growyr(in,2,nl)) &
            growa(i)=(day-growyr(in,1,nl))/(growyr(in,2,nl)- &
            growyr(in,1,nl))
        if (day>=growyr(in,3,nl).and.day<growyr(in,4,nl)) &
            growa(i)=(growyr(in,4,nl)-day)/(growyr(in,4,nl)- &
            growyr(in,3,nl))
        growa(i)=max(0.0,min(growa(i),1.0))
        if (growa(i)<1.0e-5) growa(i)=0.0
      end if
    end do ! loop 120
  else
    do i=il1,il2
      growa(i)=1.
    end do
  end if
  !
  !     * determine growth indices for needleleaf trees, broadleaf
  !     * trees and grass (vegetation types 1, 2 and 4); calculate
  !     * vegetation height, corrected for growth stage for crops
  !     * and for snow cover for crops and grass; calculate current
  !     * leaf area index for four vegetation types.
  !
  do i=il1,il2
    grown(i)=abs(growth(i))
    if (growth(i)>0.0) then
      growb(i)=min(1.0,growth(i)*2.0)
    else
      growb(i)=max(0.0,(abs(growth(i))*2.0-1.0))
    end if
    growg=1.0
    !
    if (ihgt==0) then
      h(i,1)=10.0*exp(zoln(i,1))
      h(i,2)=10.0*exp(zoln(i,2))
      h(i,3)=10.0*exp(zoln(i,3))*growa(i)
      h(i,4)=10.0*exp(zoln(i,4))
    else
      h(i,1)=hgtdat(i,1)
      h(i,2)=hgtdat(i,2)
      h(i,3)=hgtdat(i,3)
      h(i,4)=hgtdat(i,4)
    end if
    hs(i,1)=h(i,1)
    hs(i,2)=h(i,2)
    hs(i,3)=max(h(i,3)-zsnow(i),1.0e-3)
    hs(i,4)=max(h(i,4)-zsnow(i),1.0e-3)

    if (ipai==0) then
      !    ----------------- ctem modifications -----------------------------\
      !             USE CTEM GENERATED PAI OR CLASS' OWN SPECIFIED PAI
      if (ictemmod == 1) then
        pai(i,1)=paic(i,1)
        pai(i,2)=paic(i,2)
        pai(i,3)=paic(i,3)
        pai(i,4)=paic(i,4)
      else
        pai(i,1)=paimin(i,1)+grown(i)*(paimax(i,1)-paimin(i,1))
        pai(i,2)=paimin(i,2)+growb(i)*(paimax(i,2)-paimin(i,2))
        pai(i,3)=paimin(i,3)+growa(i)*(paimax(i,3)-paimin(i,3))
        pai(i,4)=paimin(i,4)+growg   *(paimax(i,4)-paimin(i,4))
      end if
      !    ----------------- ctem modifications -----------------------------/
      !
    else
      pai(i,1)=paidat(i,1)
      pai(i,2)=paidat(i,2)
      pai(i,3)=paidat(i,3)
      pai(i,4)=paidat(i,4)
    end if
    pais(i,1)=pai(i,1)
    pais(i,2)=pai(i,2)
    if (h(i,3)>0.0) then
      pais(i,3)=pai(i,3)*hs(i,3)/h(i,3)
    else
      pais(i,3)=0.0
    end if
    if (h(i,4)>0.0) then
      pais(i,4)=pai(i,4)*hs(i,4)/h(i,4)
    else
      pais(i,4)=0.0
    end if
    !
    !    ----------------- ctem modifications -----------------------------\
    !
    if (ictemmod == 1) then
      ail(i,1)=max(ailc(i,1), slaic(i,1))
      ail(i,2)=max(ailc(i,2), slaic(i,2))
      ail(i,3)=max(ailc(i,3), slaic(i,3))
      ail(i,4)=max(ailc(i,4), slaic(i,4))
    else
      !    ----------------- ctem modifications -----------------------------/
      !
      ail(i,1)=pai(i,1)*0.90
      ail(i,2)=max((pai(i,2)-paimin(i,2)),0.0)
      ail(i,3)=pai(i,3)
      ail(i,4)=pai(i,4)
    end if

    !    ----------------- ctem modifications -----------------------------\
    !
    !         ESTIMATE GREEN LAI FOR CANOPY OVER SNOW FRACTION FOR CTEM's
    !         9 pfts, just like class does.
    !
    if (ictemmod==1) then
      ailcgs(i,1)=ailcg(i,1)    ! ndl evg
      ailcgs(i,2)=ailcg(i,2)    ! ndl dcd
      ailcgs(i,3)=ailcg(i,3)    ! bdl evg
      ailcgs(i,4)=ailcg(i,4)    ! bdl dcd cld
      ailcgs(i,5)=ailcg(i,5)    ! bdl dcd dry
      if (h(i,3)>0.0) then
        ailcgs(i,6)=ailcg(i,6)*hs(i,3)/h(i,3)  ! c3 crop
        ailcgs(i,7)=ailcg(i,7)*hs(i,3)/h(i,3)  ! c4 crop
      else
        ailcgs(i,6)=0.0
        ailcgs(i,7)=0.0
      end if
      if (h(i,4)>0.0) then
        ailcgs(i,8)=ailcg(i,8)*hs(i,4)/h(i,4)  ! c3 grass
        ailcgs(i,9)=ailcg(i,9)*hs(i,4)/h(i,4)  ! c4 grass
      else
        ailcgs(i,8)=0.0
        ailcgs(i,9)=0.0
      end if
    end if
    !    ----------------- ctem modifications -----------------------------/
    !
  end do ! loop 150
  !
  !     * adjust fractional coverage of grid cell for crops and
  !     * grass if lai falls below a set threshold value due to
  !     * growth stage or snow cover; reset lai to the threshold
  !     * value; calculate resultant grid cell coverage by canopy,
  !     * bare ground, canopy over snow and snow over bare ground.
  !     *
  !     * also calculate surface detention capacity for four
  !     * grid cell subareas based on values supplied by
  !     * u. of waterloo:
  !     *        impermeable surfaces: 0.001 m.
  !     *        bare soil:            0.002 m.
  !     *        low vegetation:       0.003 m.
  !     *        forest:               0.01  m.
  !
  thr_lai=1.0
  !
  do i=il1,il2
    fcan(i,1)=fcanmx(i,1)*(1.0-fsnow(i))
    fcan(i,2)=fcanmx(i,2)*(1.0-fsnow(i))
    if (fcan(i,1)<1.0e-5) fcan(i,1)=0.0
    if (fcan(i,2)<1.0e-5) fcan(i,2)=0.0
    if (pai(i,3)<thr_lai) then
      fcan(i,3)=fcanmx(i,3)*(1.0-fsnow(i))*pai(i,3)
      pai (i,3)=thr_lai
    else
      fcan(i,3)=fcanmx(i,3)*(1.0-fsnow(i))
    end if
    if (pai(i,4)<thr_lai) then
      fcan(i,4)=fcanmx(i,4)*(1.0-fsnow(i))*pai(i,4)
      pai (i,4)=thr_lai
    else
      fcan(i,4)=fcanmx(i,4)*(1.0-fsnow(i))
    end if
    if (fcan(i,3)<1.0e-5) fcan(i,3)=0.0
    if (fcan(i,4)<1.0e-5) fcan(i,4)=0.0
    !
    fcans(i,1)=fcanmx(i,1)*fsnow(i)
    fcans(i,2)=fcanmx(i,2)*fsnow(i)
    if (fcans(i,1)<1.0e-5) fcans(i,1)=0.0
    if (fcans(i,2)<1.0e-5) fcans(i,2)=0.0
    if (pais(i,3)<thr_lai) then
      fcans(i,3)=fcanmx(i,3)*fsnow(i)*pais(i,3)
      pais (i,3)=thr_lai
    else
      fcans(i,3)=fcanmx(i,3)*fsnow(i)
    end if
    if (pais(i,4)<thr_lai) then
      fcans(i,4)=fcanmx(i,4)*fsnow(i)*pais(i,4)
      pais (i,4)=thr_lai
    else
      fcans(i,4)=fcanmx(i,4)*fsnow(i)
    end if
    if (fcans(i,3)<1.0e-5) fcans(i,3)=0.0
    if (fcans(i,4)<1.0e-5) fcans(i,4)=0.0
    !
    fc (i)=fcan(i,1)+fcan(i,2)+fcan(i,3)+fcan(i,4)
    fg (i)=1.0-fsnow(i)-fc(i)
    fcs(i)=fcans(i,1)+fcans(i,2)+fcans(i,3)+fcans(i,4)
    fgs(i)=fsnow(i)-fcs(i)
    if (abs(1.0-fcs(i)-fc(i))<8.0e-5) then
      if (fcs(i)<1.0e-5) then
        fsnow (i)=0.0
      else if (fc(i)<1.0e-5) then
        fsnow(i)= 1.0
      end if
      if (fcs(i)>0.) then
        fcans(i,1)=fcans(i,1)*fsnow(i)/fcs(i)
        fcans(i,2)=fcans(i,2)*fsnow(i)/fcs(i)
        fcans(i,3)=fcans(i,3)*fsnow(i)/fcs(i)
        fcans(i,4)=fcans(i,4)*fsnow(i)/fcs(i)
      end if
      if (fc(i)>0.) then
        fcan(i,1)=fcan(i,1)*(1.0-fsnow(i))/fc(i)
        fcan(i,2)=fcan(i,2)*(1.0-fsnow(i))/fc(i)
        fcan(i,3)=fcan(i,3)*(1.0-fsnow(i))/fc(i)
        fcan(i,4)=fcan(i,4)*(1.0-fsnow(i))/fc(i)
      end if
      fcs(i)=min(fsnow(i),1.0)
      fc(i)=1.0-fcs(i)
      fgs(i)=0.0
      fg(i)=0.0
    end if
    fc (i)=max(fc (i),0.0)
    fg (i)=max(fg (i),0.0)
    fcs(i)=max(fcs(i),0.0)
    fgs(i)=max(fgs(i),0.0)
    fsum=(fcs(i)+fgs(i)+fc(i)+fg(i))
    fc (i)=fc (i)/fsum
    fg (i)=fg (i)/fsum
    fcs(i)=fcs(i)/fsum
    fgs(i)=fgs(i)/fsum
    if (abs(1.0-fcs(i)-fgs(i)-fc(i)-fg(i))>1.0e-5) &
        call xit('APREP',-1)
    !
    if (iwf==0) then
      if (isand(i,1)==-4) then
        zplimg(i)=0.001
      else if (isand(i,1)==-3) then
        zplimg(i)=0.001
      else
        zplimg(i)=0.002
      end if
      if (fgs(i)>0.0) then
        zplmgs(i)=(zplimg(i)*fsnow(i)*(1.0-fcanmx(i,1)- &
                       fcanmx(i,2)-fcanmx(i,3)-fcanmx(i,4))+ &
                       zplimg(i)*(fsnow(i)*fcanmx(i,3)- &
                       fcans(i,3))+0.003*(fsnow(i)*fcanmx(i,4)- &
                       fcans(i,4)))/fgs(i)
      else
        zplmgs(i)=0.0
      end if
      if (fc(i)>0.0) then
        zplimc(i)=(0.01*(fcan(i,1)+fcan(i,2))+0.003* &
                       (fcan(i,3)+fcan(i,4)))/fc(i)
      else
        zplimc(i)=0.0
      end if
      if (fcs(i)>0.0) then
        zplmcs(i)=(0.01*(fcans(i,1)+fcans(i,2))+0.003* &
                       (fcans(i,3)+fcans(i,4)))/fcs(i)
      else
        zplmcs(i)=0.0
      end if
    else
      zplmcs(i)=zplms0(i)
      zplmgs(i)=zplms0(i)
      zplimc(i)=zplmg0(i)
      zplimg(i)=zplmg0(i)
    end if
  end do ! loop 175
  !
  !     * partition intercepted liquid and frozen moisture between
  !     * canopy overlying bare ground and canopy overlying snow,
  !     * using different effective leaf areas for each.  add
  !     * residual to soil moisture or snow (if present); calculate
  !     * relative fractions of liquid and frozen intercepted
  !     * moisture on canopy.
  !
  do i=il1,il2
    if (fc(i)>0.) then
      paican(i)=(fcan(i,1)*pai(i,1)+fcan(i,2)*pai(i,2)+ &
                    fcan(i,3)*pai(i,3)+fcan(i,4)*pai(i,4))/fc(i)
    else
      paican(i)=0.0
    end if
    if (fcs(i)>0.) then
      paicns(i)=(fcans(i,1)*pais(i,1)+fcans(i,2)*pais(i,2)+ &
                    fcans(i,3)*pais(i,3)+fcans(i,4)*pais(i,4))/ &
                    fcs(i)
    else
      paicns(i)=0.0
    end if
    !
    cwlcap(i)=0.20*paican(i)
    cwlcps(i)=0.20*paicns(i)
    !
    rresid(i)=0.0
    if (rcan(i)<1.0e-5 .or. (fc(i)+fcs(i))<1.0e-5) then
      rresid(i)=rresid(i)+rcan(i)
      rcan(i)=0.0
    end if
    !
    if (rcan(i)>0. .and. (fc(i)+fcs(i))>0.) then
      rcan(i)=rcan(i)/(fc(i)+fcs(i))
      if (paican(i)>0.0) then
        raican(i)=rcan(i)*(fc(i)+fcs(i))/(fc(i)+fcs(i)* &
                       paicns(i)/paican(i))
      else
        raican(i)=0.0
      end if
      if (paicns(i)>0.0) then
        raicns(i)=rcan(i)*(fc(i)+fcs(i))/(fcs(i)+fc(i)* &
                       paican(i)/paicns(i))
      else
        raicns(i)=0.0
      end if
    else
      raican(i)=0.0
      raicns(i)=0.0
    end if
    !
    if (fc(i)>0.) then
      paican(i)=(0.7*fcan(i,1)*pai(i,1)+fcan(i,2)*pai(i,2)+ &
                    fcan(i,3)*pai(i,3)+fcan(i,4)*pai(i,4))/fc(i)
    else
      paican(i)=0.0
    end if
    if (fcs(i)>0.) then
      paicns(i)=(0.7*fcans(i,1)*pais(i,1)+fcans(i,2)*pais(i,2)+ &
                    fcans(i,3)*pais(i,3)+fcans(i,4)*pais(i,4))/ &
                    fcs(i)
    else
      paicns(i)=0.0
    end if
    !
    cwfcap(i)=6.0*paican(i)*(0.27+46.0/rhosni(i))
    cwfcps(i)=6.0*paicns(i)*(0.27+46.0/rhosni(i))
    !
    sresid(i)=0.0
    if (sncan(i)<1.0e-5 .or. (fc(i)+fcs(i))<1.0e-5) then
      sresid(i)=sresid(i)+sncan(i)
      sncan(i)=0.0
    end if
    !
    if (sncan(i)>0. .and. (fc(i)+fcs(i))>0.) then
      sncan(i)=sncan(i)/(fc(i)+fcs(i))
      if (paican(i)>0.0) then
        snocan(i)=sncan(i)*(fc(i)+fcs(i))/(fc(i)+fcs(i)* &
                       paicns(i)/paican(i))
      else
        snocan(i)=0.0
      end if
      if (paicns(i)>0.0) then
        snocns(i)=sncan(i)*(fc(i)+fcs(i))/(fcs(i)+fc(i)* &
                       paican(i)/paicns(i))
      else
        snocns(i)=0.0
      end if
    else
      snocan(i)=0.0
      snocns(i)=0.0
    end if
    !
    if (cwfcap(i)>0.0) then
      fsnowc(i)=min(snocan(i)/cwfcap(i),1.0)
    else
      fsnowc(i)=0.0
    end if
    if (cwfcps(i)>0.0) then
      fsnocs(i)=min(snocns(i)/cwfcps(i),1.0)
    else
      fsnocs(i)=0.0
    end if
    !
    if (cwlcap(i)>0.0) then
      frainc(i)=min(raican(i)/cwlcap(i),1.0)
    else
      frainc(i)=0.0
    end if
    if (cwlcps(i)>0.0) then
      fraics(i)=min(raicns(i)/cwlcps(i),1.0)
    else
      fraics(i)=0.0
    end if
    frainc(i)=max(0.0,min(frainc(i)-fsnowc(i),1.0))
    fraics(i)=max(0.0,min(fraics(i)-fsnocs(i),1.0))
    !
    if (raican(i)>cwlcap(i)) then
      rresid(i)=rresid(i)+fc(i)*(raican(i)-cwlcap(i))
      raican(i)=cwlcap(i)
    end if
    if (snocan(i)>cwfcap(i)) then
      sresid(i)=sresid(i)+fc(i)*(snocan(i)-cwfcap(i))
      snocan(i)=cwfcap(i)
    end if
    !
    if (raicns(i)>cwlcps(i)) then
      rresid(i)=rresid(i)+fcs(i)*(raicns(i)-cwlcps(i))
      raicns(i)=cwlcps(i)
    end if
    if (snocns(i)>cwfcps(i)) then
      sresid(i)=sresid(i)+fcs(i)*(snocns(i)-cwfcps(i))
      snocns(i)=cwfcps(i)
    end if
    !
    wtrc (i)=wtrc(i)-(rresid(i)+sresid(i))/delt
    htcc (i)=htcc(i)-tcan(i)*(sphw*rresid(i)+sphice*sresid(i))/ &
              delt
    if (fsnow(i)>0.0) then
      snoi=sno(i)
      zsnadd=sresid(i)/(rhosno(i)*fsnow(i))
      zsnow(i)=zsnow(i)+zsnadd
      sno(i)=zsnow(i)*fsnow(i)*rhosno(i)
      tsnow(i)=(tcan(i)*sphice*sresid(i)+tsnow(i)*hcpice* &
                  snoi/rhoice)/(hcpice*sno(i)/rhoice)
      htcs (i)=htcs(i)+tcan(i)*sphice*sresid(i)/delt
      wtrs (i)=wtrs(i)+sresid(i)/delt
      sresid(i)=0.0
    end if
    !
    do j=1,ig
      if (delzw(i,j)>0.0 .and. (rresid(i)>0.0 &
          .or. sresid(i)>0.0)) then
        thsum=thliq(i,j)+thice(i,j)+ &
                 (rresid(i)+sresid(i))/(rhow*delzw(i,j))
        if (thsum<thpor(i,j)) then
          thicei=thice(i,j)
          thliqi=thliq(i,j)
          thice(i,j)=thice(i,j)+sresid(i)/ &
                     (rhoice*delzw(i,j))
          thliq(i,j)=thliq(i,j)+rresid(i)/ &
                     (rhow*delzw(i,j))
          tbar(i,j)=(tbar(i,j)*((delz(j)-delzw(i,j))* &
                     hcpsnd+delzw(i,j)*(thliqi*hcpw+thicei* &
                     hcpice+(1.0-thpor(i,j))*hcps(i,j)))+tcan(i)* &
                     (rresid(i)*hcpw/rhow+sresid(i)*hcpice/rhoice)) &
                     /((delz(j)-delzw(i,j))*hcpsnd+delzw(i,j)* &
                     (hcpw*thliq(i,j)+hcpice*thice(i,j)+hcps(i,j)* &
                     (1.0-thpor(i,j))))
          htc(i,j)=htc(i,j)+tcan(i)*(rresid(i)*hcpw/rhow+ &
                     sresid(i)*hcpice/rhoice)/delt
          wtrg (i)=wtrg(i)+(rresid(i)+sresid(i))/delt
          rresid(i)=0.0
          sresid(i)=0.0
        end if
      end if
    end do ! loop 190
    !
  end do ! loop 200
  !
  !     * calculation of roughness lengths for heat and momentum and
  !     * zero-plane displacement for canopy overlying bare soil and
  !     * canopy overlying snow.
  !
  do j=1,ic
    do i=il1,il2
      if (fc(i)>0. .and. h(i,j)>0.) then
        if (idisp==1)   disp(i)=disp(i)+fcan (i,j)* &
            log(0.7*h(i,j))
        zomlnc(i)=zomlnc(i)+fcan (i,j)/ &
                   ((log(zblend(i)/(0.1*h(i,j))))**2)
        zoelnc(i)=zoelnc(i)* &
                   (0.01*h(i,j)*h(i,j)/zorat(ic))**fcan(i,j)
      end if
      if (fcs(i)>0. .and. hs(i,j)>0.) then
        if (idisp==1)   disps(i)=disps (i)+fcans(i,j)* &
            log(0.7*hs(i,j))
        zomlcs(i)=zomlcs(i)+fcans(i,j)/ &
                   ((log(zblend(i)/(0.1*hs(i,j))))**2)
        zoelcs(i)=zoelcs(i)* &
                   (0.01*hs(i,j)*hs(i,j)/zorat(ic))**fcans(i,j)
      end if
    end do
  end do ! loop 250
  !
  do i=il1,il2
    if (fc(i)>0.) then
      if (idisp==1)   disp(i)=exp(disp(i)/fc(i))
      zomlnc(i)=zblend(i)/exp(sqrt(1.0/(zomlnc(i)/fc(i))))
      zoelnc(i)=log(zoelnc(i)**(1.0/fc(i))/zomlnc(i))
      zomlnc(i)=log(zomlnc(i))
    end if
    if (fcs(i)>0.) then
      if (idisp==1)   disps(i)=exp(disps(i)/fcs(i))
      zomlcs(i)=zblend(i)/exp(sqrt(1.0/(zomlcs(i)/fcs(i))))
      zoelcs(i)=log(zoelcs(i)**(1.0/fcs(i))/zomlcs(i))
      zomlcs(i)=log(zomlcs(i))
    end if
  end do ! loop 275
  !
  !     * adjust roughness lengths of bare soil and snow-covered bare
  !     * soil for urban roughness if present.
  !
  do i=il1,il2
    if (fg(i)>0.) then
      if (isand(i,1)/=-4) then
        zomlng(i)=((fg(i)-fcanmx(i,5)*(1.0-fsnow(i)))*zolng+ &
                       fcanmx(i,5)*(1.0-fsnow(i))*zoln(i,5))/fg(i)
      else
        zomlng(i)=zolni
      end if
      zoelng(i)=zomlng(i)-log(zoratg)
    end if
    if (fgs(i)>0.) then
      zomlns(i)=((fgs(i)-fcanmx(i,5)*fsnow(i))*zolns+ &
                   fcanmx(i,5)*fsnow(i)*zoln(i,5))/fgs(i)
      zoelns(i)=zomlns(i)-log(zoratg)
    end if
  end do ! loop 300
  !
  !     * add contribution of orography to momentum roughness length
  !
  do i=il1,il2
    if (z0oro(i)>1.0e-4) then
      lz0oro=log(z0oro(i))
    else
      lz0oro=-10.0
    end if
    zomlnc(i)=max(zomlnc(i),lz0oro)
    zomlcs(i)=max(zomlcs(i),lz0oro)
    zomlng(i)=max(zomlng(i),lz0oro)
    zomlns(i)=max(zomlns(i),lz0oro)
  end do ! loop 325
  !
  !     * calculate heat capacity for canopy overlying bare soil and
  !     * canopy overlying snow.
  !     * also calculate instantaneous grid-cell averaged canopy mass.
  !
  do i=il1,il2
    if (fc(i)>0.) then
      cmassc(i)=(fcan(i,1)*cwgtmx(i,1)+fcan (i,2)*cwgtmx(i,2)+ &
                    fcan(i,3)*cwgtmx(i,3)*growa(i)+ &
                    fcan(i,4)*cwgtmx(i,4))/fc (i)
      !
      if (idisp==0) then
        cmassc(i)=cmassc(i)+rhoair(i)*(sphair/sphveg)*0.7* &
                      (fcan(i,1)*h(i,1)+fcan(i,2)*h(i,2)+ &
                       fcan(i,3)*h(i,3)+fcan(i,4)*h(i,4))/fc(i)
      end if
      if (izref==2) then
        cmassc(i)=cmassc(i)+rhoair(i)*(sphair/sphveg)*0.1* &
                      (fcan(i,1)*h(i,1)+fcan(i,2)*h(i,2)+ &
                       fcan(i,3)*h(i,3)+fcan(i,4)*h(i,4))/fc(i)
      end if
    end if
    if (fcs(i)>0.) then
      cmascs(i)=(fcans(i,1)*cwgtmx(i,1)+fcans(i,2)*cwgtmx(i,2)+ &
                    fcans(i,3)*cwgtmx(i,3)*growa(i) &
                   *hs(i,3)/max(h(i,3),hs(i,3))+ &
                    fcans(i,4)*cwgtmx(i,4) &
                   *hs(i,4)/max(h(i,4),hs(i,4)))/fcs(i)
      !
      if (idisp==0) then
        cmascs(i)=cmascs(i)+rhoair(i)*(sphair/sphveg)*0.7* &
                       (fcans(i,1)*hs(i,1)+fcans(i,2)*hs(i,2)+ &
                        fcans(i,3)*hs(i,3)+fcans(i,4)*hs(i,4))/ &
                        fcs(i)
      end if
      if (izref==2) then
        cmascs(i)=cmascs(i)+rhoair(i)*(sphair/sphveg)*0.1* &
                       (fcans(i,1)*hs(i,1)+fcans(i,2)*hs(i,2)+ &
                        fcans(i,3)*hs(i,3)+fcans(i,4)*hs(i,4))/ &
                        fcs(i)
      end if
    end if

    chcap (i)=sphveg*cmassc(i)+sphw*raican(i)+sphice*snocan(i)
    chcaps(i)=sphveg*cmascs(i)+sphw*raicns(i)+sphice*snocns(i)
    htcc  (i)=htcc(i)-sphveg*cmai(i)*tcan(i)/delt
    if (cmai(i)<1.0e-5 .and. (cmassc(i)>0.0 .or. &
        cmascs(i)>0.0)) tcan(i)=ta(i)
    cmai  (i)=fc(i)*cmassc(i)+fcs(i)*cmascs(i)
    htcc  (i)=htcc(i)+sphveg*cmai(i)*tcan(i)/delt
    rbcoef(i)=0.0
  end do ! loop 350
  !
  !     * calculate vegetation rooting depth and fraction of roots
  !     * in each soil layer (same for snow/bare soil cases).
  !     * also calculate leaf boundary resistance parameter rbcoef.
  !
  do j=1,ic
    do i=il1,il2
      if (ictemmod==1) then
        rmat(i,j,1)=rmatc(i,j,1)
        rmat(i,j,2)=rmatc(i,j,2)
        rmat(i,j,3)=rmatc(i,j,3)
      else
        zroot=zrtmax(i,j)
        if (j==3) zroot=zrtmax(i,j)*growa(i)
        zrootg=0.0
        do k=1,ig
          zrootg=zrootg+delzw(i,k)
        end do ! loop 375
        zroot=min(zroot,zrootg)
        do k=1,ig
          if (zroot<=(zbotw(i,k)-delzw(i,k)+0.0001)) then
            rmat(i,j,k)=0.0
          else if (zroot<=zbotw(i,k)) then
            rmat(i,j,k)=(exp(-3.0*(zbotw(i,k)-delzw(i,k)))- &
                 exp(-3.0*zroot))/(1.0-exp(-3.0*zroot))
          else
            rmat(i,j,k)=(exp(-3.0*(zbotw(i,k)-delzw(i,k)))- &
                 exp(-3.0*zbotw(i,k)))/(1.0-exp(-3.0*zroot))
          end if
        end do ! loop 400
      end if
      !
      if ((fc(i)+fcs(i))>0.) then
        rbcoef(i)=rbcoef(i)+ &
                 (fcan(i,j)*xleaf(j)*(sqrt(pai(i,j))/0.75)* &
                 (1.0-exp(-0.75*sqrt(pai(i,j))))+ &
                 fcans(i,j)*xleaf(j)*(sqrt(pais(i,j))/0.75)* &
                 (1.0-exp(-0.75*sqrt(pais(i,j)))))/ &
                 (fc(i)+fcs(i))
      end if
    end do
  end do ! loop 450
  !
  do j=1,ig
    do i=il1,il2
      if (fc(i)>0.) then
        froot(i,j)=(fcan(i,1)*rmat(i,1,j) + &
                     fcan(i,2)*rmat(i,2,j) + &
                     fcan(i,3)*rmat(i,3,j) + &
                     fcan(i,4)*rmat(i,4,j))/fc(i)
      else
        froot(i,j)=0.0
      end if
      if (fcs(i)>0.) then
        froots(i,j)=(fcans(i,1)*rmat(i,1,j) + &
                      fcans(i,2)*rmat(i,2,j) + &
                      fcans(i,3)*rmat(i,3,j) + &
                      fcans(i,4)*rmat(i,4,j))/fcs(i)
      else
        froots(i,j)=0.0
      end if
    end do
  end do ! loop 500
  !
  !     * calculate sky-view factors for bare ground and snow
  !     * underlying canopy.
  !
  do i=il1,il2
    if (fc(i)>0.) then
      fsvf (i)=(fcan (i,1)*exp(canext(1)*pai (i,1)) + &
                   fcan (i,2)*exp(canext(2)*pai (i,2)) + &
                   fcan (i,3)*exp(canext(3)*pai (i,3)) + &
                   fcan (i,4)*exp(canext(4)*pai (i,4)))/fc (i)
    else
      fsvf (i)=0.
    end if
    if (fcs(i)>0.) then
      fsvfs(i)=(fcans(i,1)*exp(canext(1)*pais(i,1)) + &
                   fcans(i,2)*exp(canext(2)*pais(i,2)) + &
                   fcans(i,3)*exp(canext(3)*pais(i,3)) + &
                   fcans(i,4)*exp(canext(4)*pais(i,4)))/fcs(i)
    else
      fsvfs(i)=0.
    end if
  end do ! loop 600
  !
  !     * calculate bulk soil moisture suction for stomatal resistance.
  !     * calculate fractional transpiration extracted from soil layers.
  !
  do j=1,ig
    do i=il1,il2
      if (fcs(i)>0.0 .or. fc(i)>0.0) then
        if(isand(i,j).eq.-3)                   then
            froot(i,j)=0.0
            froots(i,j)=0.0
        else
          if (thliq(i,j)>(thlmin(i,j)+0.01)) then
            psii=psisat(i,j)*(thliq(i,j)/thpor(i,j))**(-bi(i,j))
            psii=min(psii,psiwlt(i,j))
            if (froot(i,j)>0.0) psignd(i)=min(psignd(i),psii)
            psirat=(psiwlt(i,j)-psii)/(psiwlt(i,j)-psisat(i,j))
            froot(i,j)=froot(i,j)*psirat
            froots(i,j)=froots(i,j)*psirat
            frtot(i)=frtot(i)+froot(i,j)
            frtots(i)=frtots(i)+froots(i,j)
          else
            froot(i,j)=0.0
            froots(i,j)=0.0
          end if
        endif
      end if
    end do
  end do ! loop 650
  !
  do j=1,ig
    do i=il1,il2
      if (frtot(i)>0.) then
        froot(i,j)=froot(i,j)/frtot(i)
      end if
      if (frtots(i)>0.) then
        froots(i,j)=froots(i,j)/frtots(i)
      end if
    end do
  end do ! loop 700
  !
  !     * calculate effective leaf area indices for transpiration.
  !
  do i=il1,il2
    if (fc(i)>0.) then
      paican(i)=(fcan(i,1)*pai(i,1)+fcan(i,2)*pai(i,2)+ &
                    fcan(i,3)*pai(i,3)+fcan(i,4)*pai(i,4))/fc(i)
    else
      paican(i)=0.0
    end if
    if (fcs(i)>0.) then
      paicns(i)=(fcans(i,1)*pais(i,1)+fcans(i,2)*pais(i,2)+ &
                    fcans(i,3)*pais(i,3)+fcans(i,4)*pais(i,4))/ &
                    fcs(i)
    else
      paicns(i)=0.0
    end if
  end do ! loop 800
  !
  if (ictemmod==1) then
    !
    !       * estimate fcanc and fcancs for use by phtsyn subroutine based on
    !       * fcan and fcans for ctem pfts.
    !
    do j = 1, ic
      do i = il1, il2
        sfcancmx(i,j)=0.0  ! sum of fcancmxs
      end do
    end do ! loop 810
    !
    k1=0
    do j = 1, ic
      if (j==1) then
        k1 = k1 + 1
      else
        k1 = k1 + nol2pfts(j-1)
      end if
      k2 = k1 + nol2pfts(j) - 1
      do m = k1, k2
        do i = il1, il2
          sfcancmx(i,j)=sfcancmx(i,j)+fcancmx(i,m)
        end do
      end do ! loop 820
    end do ! loop 830
    !
    k1=0
    do j = 1, ic
      if (j==1) then
        k1 = k1 + 1
      else
        k1 = k1 + nol2pfts(j-1)
      end if
      k2 = k1 + nol2pfts(j) - 1
      do m = k1, k2
        do i = il1, il2
          if (sfcancmx(i,j)>1.e-20) then
            fcanc(i,m)  = fcan(i,j) * (fcancmx(i,m)/sfcancmx(i,j))
            fcancs(i,m) = fcans(i,j)* (fcancmx(i,m)/sfcancmx(i,j))
          else
            fcanc(i,m)  = 0.0
            fcancs(i,m) = 0.0
          end if
        end do
      end do ! loop 850
    end do ! loop 860
  end if
  !
  return
end subroutine aprep
